diff --git a/Client/Client/Assets/Scripts/RushManager.cs b/Client/Client/Assets/Scripts/RushManager.cs
index 4fcc2a2..568cc80 100644
--- a/Client/Client/Assets/Scripts/RushManager.cs
+++ b/Client/Client/Assets/Scripts/RushManager.cs
@@ -104,7 +104,7 @@ public class RushManager : MonoBehaviour
         Redraw();
     }
 
-    public void CreateRequest(Date startDate, Date endDate)
+    public void CreateRequest(Date startDate, Date endDate, bool useOwnWeather)
     {
         this.response = null;
         
@@ -113,7 +113,7 @@ public class RushManager : MonoBehaviour
         request.useEndDate = endDate != null;
         request.end = endDate;
 
-        weatherManager.SetWeather(request);
+        weatherManager.SetWeather(request, useOwnWeather);
         networkingManager.StartPost(request);
     }
 
@@ -204,7 +204,7 @@ public class RushManager : MonoBehaviour
         var lastPred = response.predicitons[response.predicitons.Length-1];
 
         dateTimeManager.SetDates(currentPrediction.dateTime, firstPred.dateTime, lastPred.dateTime);
-        // TODO update weather
+        weatherManager.SetDateTime(currentPrediction.dateTime);
         mapRenderer.SetColors(currentPrediction.predictions);
     }
 
diff --git a/Client/Client/Assets/Scripts/Shaders/MapNotAvailable.shader b/Client/Client/Assets/Scripts/Shaders/MapNotAvailable.shader
new file mode 100644
index 0000000..91367cb
--- /dev/null
+++ b/Client/Client/Assets/Scripts/Shaders/MapNotAvailable.shader
@@ -0,0 +1,111 @@
+﻿// Based on Unity's Sprites/Default
+// And this Unity forum thread: https://answers.unity.com/questions/1624176/changing-the-sprite-renderers-color-property-has-n.html
+
+Shader "Unlit/MapNotAvailable"
+{
+	Properties
+	{
+		[PerRendererData] _MainTex("Sprite Texture", 2D) = "white" {}
+		_Color1("Color 1", Color) = (0,0,0,1)
+		_Color2("Color 2", Color) = (1,1,1,1)
+		_Tiling("Tiling", Range(1, 750)) = 10
+		_Direction("Direction", Range(0, 1)) = 0
+	}
+
+		SubShader
+		{
+			Tags
+			{
+				"Queue" = "Transparent"
+				"IgnoreProjector" = "True"
+				"RenderType" = "Transparent"
+				"PreviewType" = "Plane"
+				"CanUseSpriteAtlas" = "True"
+			}
+
+			Cull Off
+			Lighting Off
+			ZWrite Off
+			Blend One OneMinusSrcAlpha
+
+			Pass
+			{
+			CGPROGRAM
+				#pragma vertex vert
+				#pragma fragment frag
+				#include "UnityCG.cginc"
+
+				struct appdata_t
+				{
+					float4 vertex   : POSITION;
+					float4 color    : COLOR;
+					float2 texcoord : TEXCOORD0;
+				};
+
+				struct v2f
+				{
+					float4 vertex   : SV_POSITION;
+					fixed4 color	: COLOR;
+					float2 texcoord : TEXCOORD0;
+				};
+
+
+				v2f vert(appdata_t IN)
+				{
+					v2f OUT;
+					OUT.vertex = UnityObjectToClipPos(IN.vertex);
+					OUT.texcoord = IN.texcoord;
+					OUT.color = IN.color;
+					return OUT;
+				}
+
+				sampler2D _MainTex;
+				float4 _MainTex_ST;
+				float4 _MainTex_TexelSize;
+
+				sampler2D _AlphaTex;
+				float _AlphaSplitEnabled;
+
+				half4 _Color1;
+				half4 _Color2;
+				int _Tiling;
+				float _Direction;
+
+				fixed4 SampleSpriteTexture(float2 uv)
+				{
+					fixed4 color = tex2D(_MainTex, uv);
+
+					#if UNITY_TEXTURE_ALPHASPLIT_ALLOWED
+					if (_AlphaSplitEnabled)
+						color.a = tex2D(_AlphaTex, uv).r;
+					#endif //UNITY_TEXTURE_ALPHASPLIT_ALLOWED
+
+					return color;
+				}
+
+				fixed4 frag(v2f i) : SV_Target
+				{
+					float2 pos;
+					
+					float aspect = _MainTex_TexelSize.w / _MainTex_TexelSize.z;
+					float x = i.texcoord.x;
+					float y = i.texcoord.y * aspect;
+
+					pos.x = lerp(x, -y, _Direction);
+					pos.y = lerp(y, 1 - x, _Direction);
+
+					_Tiling *= _MainTex_TexelSize.z / (1920);
+
+					pos.x *= _Tiling;
+
+					fixed value = floor(frac(pos.x) + 0.5);
+					value = lerp(_Color1, _Color2, value);
+					
+					fixed4 c = SampleSpriteTexture(i.texcoord) * i.color;
+					return fixed4(value, value, value, c.a);
+				}
+
+			ENDCG
+			}
+		}
+}
\ No newline at end of file
diff --git a/Client/Client/Assets/Scripts/Shaders/MapNotAvailable.shader.meta b/Client/Client/Assets/Scripts/Shaders/MapNotAvailable.shader.meta
new file mode 100644
index 0000000..2d5b70d
--- /dev/null
+++ b/Client/Client/Assets/Scripts/Shaders/MapNotAvailable.shader.meta
@@ -0,0 +1,9 @@
+fileFormatVersion: 2
+guid: 790700d2551c07b4c8d26f7323653bfa
+ShaderImporter:
+  externalObjects: {}
+  defaultTextures: []
+  nonModifiableTextures: []
+  userData: 
+  assetBundleName: 
+  assetBundleVariant: 
diff --git a/Client/Client/Assets/Scripts/Shaders/Stripes.shader b/Client/Client/Assets/Scripts/Shaders/Stripes.shader
new file mode 100644
index 0000000..a01ff26
--- /dev/null
+++ b/Client/Client/Assets/Scripts/Shaders/Stripes.shader
@@ -0,0 +1,67 @@
+﻿Shader "Unlit/Stripes"
+{
+	Properties{
+		_Color1("Color 1", Color) = (0,0,0,1)
+		_Color2("Color 2", Color) = (1,1,1,1)
+		_Tiling("Tiling", Range(1, 500)) = 10
+		_Direction("Direction", Range(0, 1)) = 0
+		_WarpScale("Warp Scale", Range(0, 1)) = 0
+		_WarpTiling("Warp Tiling", Range(1, 10)) = 1
+	}
+
+		SubShader
+	{
+
+		Pass
+		{
+			CGPROGRAM
+			#pragma vertex vert
+			#pragma fragment frag
+
+			#include "UnityCG.cginc"
+
+			fixed4 _Color1;
+			fixed4 _Color2;
+			int _Tiling;
+			float _Direction;
+			float _WarpScale;
+			float _WarpTiling;
+
+			struct appdata
+			{
+				float4 vertex : POSITION;
+				float2 uv : TEXCOORD0;
+			};
+
+			struct v2f
+			{
+				float2 uv : TEXCOORD0;
+				float4 vertex : SV_POSITION;
+			};
+
+			v2f vert(appdata v)
+			{
+				v2f o;
+				o.vertex = UnityObjectToClipPos(v.vertex);
+				o.uv = v.uv;
+				return o;
+			}
+
+			fixed4 frag(v2f i) : SV_Target
+			{
+				const float PI = 3.14159;
+
+				float2 pos;
+				pos.x = lerp(i.uv.x, i.uv.y, _Direction);
+				pos.y = lerp(i.uv.y, 1 - i.uv.x, _Direction);
+
+				pos.x += sin(pos.y * _WarpTiling * PI * 2) * _WarpScale;
+				pos.x *= _Tiling;
+
+				fixed value = floor(frac(pos.x) + 0.5);
+				return lerp(_Color1, _Color2, value);
+			}
+			ENDCG
+		}
+	}
+}
\ No newline at end of file
diff --git a/Client/Client/Assets/Scripts/Shaders/Stripes.shader.meta b/Client/Client/Assets/Scripts/Shaders/Stripes.shader.meta
new file mode 100644
index 0000000..9f81122
--- /dev/null
+++ b/Client/Client/Assets/Scripts/Shaders/Stripes.shader.meta
@@ -0,0 +1,9 @@
+fileFormatVersion: 2
+guid: 814ff080e4d3ea5479d70b3e08649255
+ShaderImporter:
+  externalObjects: {}
+  defaultTextures: []
+  nonModifiableTextures: []
+  userData: 
+  assetBundleName: 
+  assetBundleVariant: 
diff --git a/Client/Client/Assets/Scripts/UI/BuildingTag.cs b/Client/Client/Assets/Scripts/UI/BuildingTag.cs
new file mode 100644
index 0000000..4394c8b
--- /dev/null
+++ b/Client/Client/Assets/Scripts/UI/BuildingTag.cs
@@ -0,0 +1,8 @@
+﻿using System.Collections;
+using System.Collections.Generic;
+using UnityEngine;
+
+public class BuildingTag : MonoBehaviour
+{
+    public string builidngName;
+}
diff --git a/Client/Client/Assets/Scripts/UI/BuildingTag.cs.meta b/Client/Client/Assets/Scripts/UI/BuildingTag.cs.meta
new file mode 100644
index 0000000..f97e358
--- /dev/null
+++ b/Client/Client/Assets/Scripts/UI/BuildingTag.cs.meta
@@ -0,0 +1,11 @@
+fileFormatVersion: 2
+guid: e56204cfecaafb64fb3f94ebcf385d6b
+MonoImporter:
+  externalObjects: {}
+  serializedVersion: 2
+  defaultReferences: []
+  executionOrder: 0
+  icon: {instanceID: 0}
+  userData: 
+  assetBundleName: 
+  assetBundleVariant: 
diff --git a/Client/Client/Assets/Scripts/UI/CalendarDayButton.cs b/Client/Client/Assets/Scripts/UI/CalendarDayButton.cs
new file mode 100644
index 0000000..50ef9a8
--- /dev/null
+++ b/Client/Client/Assets/Scripts/UI/CalendarDayButton.cs
@@ -0,0 +1,73 @@
+﻿using System;
+using System.Collections;
+using System.Collections.Generic;
+using UnityEngine;
+using UnityEngine.EventSystems;
+using UnityEngine.UI;
+
+public class CalendarDayButton : MonoBehaviour
+{
+    public static int day = DateTime.Now.Day;
+    public int thisDay;
+
+    public Button setter;
+
+    private static CalendarDayButton[] buttons;
+    private Button button;
+
+    private bool first = true;
+
+    // Update is called once per frame
+    void Update()
+    {
+        if (first)
+        {
+            first = false;
+
+            if (buttons == null)
+                buttons = FindObjectsOfType<CalendarDayButton>();
+
+            button = GetComponent<Button>();
+            int days = DateTime.DaysInMonth(CalendarYear.year, CalendarMonth.month);
+            thisDay = int.Parse(button.GetComponentInChildren<Text>().text);
+
+            if (thisDay > days)
+                button.interactable = false;
+
+            if (thisDay == day)
+                EventSystem.current.SetSelectedGameObject(button.gameObject);
+            setter.interactable = true;
+        }
+        else
+        {
+            if (thisDay == day)
+                EventSystem.current.SetSelectedGameObject(button.gameObject);
+        }
+    }
+
+    public void OnClicked()
+    {
+        day = thisDay;
+        setter.interactable = true;
+    }
+
+    public static void Reset()
+    {
+        day = -1;
+        int days = DateTime.DaysInMonth(CalendarYear.year, CalendarMonth.month);
+
+        Debug.Log($"There are {days} days in year {CalendarYear.year}, month {CalendarMonth.month}.");
+
+        foreach (var btn in buttons)
+        {
+            if (btn.thisDay > days)
+                btn.button.interactable = false;
+            else
+                btn.button.interactable = true;
+        }
+
+        buttons[0].setter.interactable = false;
+        EventSystem.current.SetSelectedGameObject(null);
+    }
+
+}
diff --git a/Client/Client/Assets/Scripts/UI/CalendarDayButton.cs.meta b/Client/Client/Assets/Scripts/UI/CalendarDayButton.cs.meta
new file mode 100644
index 0000000..24d17f4
--- /dev/null
+++ b/Client/Client/Assets/Scripts/UI/CalendarDayButton.cs.meta
@@ -0,0 +1,11 @@
+fileFormatVersion: 2
+guid: e530e6e5237abc94a9c2d62a22383eea
+MonoImporter:
+  externalObjects: {}
+  serializedVersion: 2
+  defaultReferences: []
+  executionOrder: 0
+  icon: {instanceID: 0}
+  userData: 
+  assetBundleName: 
+  assetBundleVariant: 
diff --git a/Client/Client/Assets/Scripts/UI/CalendarMonth.cs b/Client/Client/Assets/Scripts/UI/CalendarMonth.cs
new file mode 100644
index 0000000..e32c274
--- /dev/null
+++ b/Client/Client/Assets/Scripts/UI/CalendarMonth.cs
@@ -0,0 +1,31 @@
+﻿using System;
+using System.Collections;
+using System.Collections.Generic;
+using UnityEngine;
+using UnityEngine.UI;
+
+public class CalendarMonth : MonoBehaviour
+{
+    public static int month = DateTime.Now.Month;
+
+    private Dropdown drop;
+    private bool first = true;
+
+    // Start is called before the first frame update
+    void Update()
+    {
+        if (first)
+        {
+            first = false;
+            drop = GetComponent<Dropdown>();
+            drop.SetValueWithoutNotify(month - 1);
+        }    
+    }
+
+    public void OnValueChanged()
+    {
+        month = drop.value + 1;
+        CalendarDayButton.Reset();
+    }
+
+}
diff --git a/Client/Client/Assets/Scripts/UI/CalendarMonth.cs.meta b/Client/Client/Assets/Scripts/UI/CalendarMonth.cs.meta
new file mode 100644
index 0000000..17c56be
--- /dev/null
+++ b/Client/Client/Assets/Scripts/UI/CalendarMonth.cs.meta
@@ -0,0 +1,11 @@
+fileFormatVersion: 2
+guid: d438485802a9c514aba4dbddf2b74923
+MonoImporter:
+  externalObjects: {}
+  serializedVersion: 2
+  defaultReferences: []
+  executionOrder: 0
+  icon: {instanceID: 0}
+  userData: 
+  assetBundleName: 
+  assetBundleVariant: 
diff --git a/Client/Client/Assets/Scripts/UI/CalendarYear.cs b/Client/Client/Assets/Scripts/UI/CalendarYear.cs
new file mode 100644
index 0000000..2b48e7d
--- /dev/null
+++ b/Client/Client/Assets/Scripts/UI/CalendarYear.cs
@@ -0,0 +1,39 @@
+﻿using System;
+using System.Collections;
+using System.Collections.Generic;
+using UnityEngine;
+using UnityEngine.UI;
+
+public class CalendarYear : MonoBehaviour
+{
+    public static int year = DateTime.Now.Year;
+
+    private Dropdown drop;
+    private bool first = true;
+
+    // Start is called before the first frame update
+    void Update()
+    {
+        if (first) {
+            first = false;
+
+            drop = GetComponent<Dropdown>();
+            drop.ClearOptions();
+
+            var options = new List<Dropdown.OptionData>();
+            options.Add(new Dropdown.OptionData("" + DateTime.Now.AddYears(-1).Year));
+            options.Add(new Dropdown.OptionData("" + DateTime.Now.Year));
+            options.Add(new Dropdown.OptionData("" + DateTime.Now.AddYears(1).Year));
+
+            drop.AddOptions(options);
+            drop.SetValueWithoutNotify(1);
+        }
+    }
+
+    public void OnValueChanged()
+    {
+        string yearString = drop.options[drop.value].text;
+        year = int.Parse(yearString);
+        CalendarDayButton.Reset();
+    }
+}
diff --git a/Client/Client/Assets/Scripts/UI/CalendarYear.cs.meta b/Client/Client/Assets/Scripts/UI/CalendarYear.cs.meta
new file mode 100644
index 0000000..2a13a2d
--- /dev/null
+++ b/Client/Client/Assets/Scripts/UI/CalendarYear.cs.meta
@@ -0,0 +1,11 @@
+fileFormatVersion: 2
+guid: bc8a369f383f0654b8f7ea3db4473073
+MonoImporter:
+  externalObjects: {}
+  serializedVersion: 2
+  defaultReferences: []
+  executionOrder: 0
+  icon: {instanceID: 0}
+  userData: 
+  assetBundleName: 
+  assetBundleVariant: 
diff --git a/Client/Client/Assets/Scripts/UI/DatePanel.cs b/Client/Client/Assets/Scripts/UI/DatePanel.cs
index 2262efd..e25716c 100644
--- a/Client/Client/Assets/Scripts/UI/DatePanel.cs
+++ b/Client/Client/Assets/Scripts/UI/DatePanel.cs
@@ -7,106 +7,143 @@ using UnityEngine.UI;
 public class DatePanel : PopUpPanel
 {
     public DateTimeManager dateTimeManager;
+    public WeatherManager weatherManager;
     public AnimationPanel animationPanel;
     public RushManager rushManager;
+    public DatePicker datePicker;
 
     public Toggle endTimeToggle;
     public Toggle weatherToggle;
 
-    public InputField startDD;
-    public InputField startMM;
-    public InputField startYYYY;
-    public InputField startHH;
+    public InputField startDate;
+    public InputField endDate;
 
-    public InputField endDD;
-    public InputField endMM;
-    public InputField endYYYY;
-    public InputField endHH;
-
-    public Button button;
+    public Button setWeather;
+    public Button resetWeather;
     public Button setDate;
     public Button resetDate;
 
-    public Animator startAnimator;
-    public Animator endAnimator;
+    public Button endCalendarButton;
+    public Dropdown startTime;
+    public Dropdown endTime;
 
-    public void OnToggleEndTime()
+    private Date start;
+    private Date end;
+
+    private string[] months = { "January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December" };
+
+    void Update()
     {
-        if (endTimeToggle.isOn)
+        if (start == null)
         {
-            endDD.interactable = true;
-            endMM.interactable = true;
-            endYYYY.interactable = true;
-            endHH.interactable = true;
+            start = new Date();
+            end = new Date();
+
+            start.day = DateTime.Now.Day;
+            start.month = DateTime.Now.Month;
+            start.year = DateTime.Now.Year;
+            start.hour = 7;
+
+            end.day = DateTime.Now.Day;
+            end.month = DateTime.Now.Month;
+            end.year = DateTime.Now.Year;
+            end.hour = 7;
         }
-        else
+
+        if (endTimeToggle.isOn && end.CompareTo(start) < 0)
         {
-            endDD.interactable = false;
-            endMM.interactable = false;
-            endYYYY.interactable = false;
-            endHH.interactable = false;
+            end.day = start.day;
+            end.month = start.month;
+            end.year = start.year;
+            end.hour = start.hour;
+
+            endTime.SetValueWithoutNotify(start.hour - 7);
         }
+
+        startDate.text = $"{start.day}. {months[start.month - 1]} {start.year}";
+        endDate.text = $"{end.day}. {months[end.month - 1]}  {end.year}";
     }
 
-    public void OnToggleWeather()
+    public void OnStartCalendarPressed()
     {
-        // TODO: Propagate
+        datePicker.gameObject.SetActive(true);
+        datePicker.toSet = start;
     }
 
-    public void OnViewButtonPressed()
+    public void OnEndCalendarPressed()
     {
-        Date startDate = new Date();
-        Date endDate = new Date();
+        datePicker.gameObject.SetActive(true);
+        datePicker.toSet = end;
+
+        if (end.CompareTo(start) < 0)
+        {
+            end.day = start.day;
+            end.month = start.month;
+            end.year = start.year;
+            end.hour = start.hour;
+        }
+    }
 
-        // Start date
+    public void OnStartHourChanged()
+    {
+        start.hour = 7 + startTime.value;
+    }
 
-        if (!IsValid(startDD.text) ||
-            !IsValid(startMM.text) ||
-            !IsValid(startYYYY.text) ||
-            !IsValid(startHH.text))
+    public void OnEndHourChanged()
+    {
+        end.hour = 7 + endTime.value;
+
+        if (end.CompareTo(start) < 0)
         {
-            startAnimator.SetTrigger("play");
-            return;
+            end.day = start.day;
+            end.month = start.month;
+            end.year = start.year;
+            end.hour = start.hour;
         }
+    }
 
-        startDate.day = int.Parse(startDD.text.Trim());
-        startDate.month = int.Parse(startMM.text.Trim());
-        startDate.year = int.Parse(startYYYY.text.Trim());
-        startDate.hour = int.Parse(startHH.text.Trim());
 
-        // End date
-        
+    public void OnToggleEndTime()
+    {
         if (endTimeToggle.isOn)
         {
-            if (!IsValid(endDD.text) ||
-                !IsValid(endMM.text) ||
-                !IsValid(endYYYY.text) ||
-                !IsValid(endHH.text))
+            endCalendarButton.interactable = true;
+            endTime.interactable = true;
+
+            if (end.CompareTo(start) < 0)
             {
-                endAnimator.SetTrigger("play");
-                return;
+                end.day = start.day;
+                end.month = start.month;
+                end.year = start.year;
+                end.hour = start.hour;
             }
-
-            endDate.day = int.Parse(endDD.text.Trim());
-            endDate.month = int.Parse(endMM.text.Trim());
-            endDate.year = int.Parse(endYYYY.text.Trim());
-            endDate.hour= int.Parse(endHH.text.Trim());
         }
         else
         {
-            endDate.day = startDate.day;
-            endDate.month = startDate.month;
-            endDate.year = startDate.year;
-            endDate.hour = startDate.hour;
+            endCalendarButton.interactable = false;
+            endTime.interactable = false;
+        }
+    }
+
+    public void OnViewButtonPressed()
+    {
+        if (!endTimeToggle.isOn)
+        {
+            end.day = start.day;
+            end.month = start.month;
+            end.year = start.year;
+            end.hour= start.hour;
         }
 
         animationPanel.gameObject.SetActive(endTimeToggle.isOn);
-        dateTimeManager.SetDates(startDate, startDate, endDate);
+        dateTimeManager.SetDates(start, start, end);
         setDate.gameObject.SetActive(false);
+        setWeather.interactable = false;
+        resetWeather.interactable = false;
         resetDate.gameObject.SetActive(true);
 
         // HANDLE SETTING THE WEATHER
-        rushManager.CreateRequest(startDate, (endTimeToggle.isOn) ? endDate : null);
+        rushManager.CreateRequest(start, (endTimeToggle.isOn) ? end : null, weatherToggle.isOn);
 
         OnExitButtonClicked();
     }
@@ -117,12 +154,12 @@ public class DatePanel : PopUpPanel
         animationPanel.ResetPanel();
         animationPanel.gameObject.SetActive(false);
         setDate.gameObject.SetActive(true);
+        setWeather.interactable = true;
+        resetWeather.interactable = true;
         resetDate.gameObject.SetActive(false);
         rushManager.ResetRush();
+        if (!weatherManager.useOwnWeather)
+            weatherManager.provider.Load();
     }
 
-    private bool IsValid(string text)
-    {
-        return true;
-    }
 }
diff --git a/Client/Client/Assets/Scripts/UI/DatePicker.cs b/Client/Client/Assets/Scripts/UI/DatePicker.cs
new file mode 100644
index 0000000..cb532cb
--- /dev/null
+++ b/Client/Client/Assets/Scripts/UI/DatePicker.cs
@@ -0,0 +1,23 @@
+﻿using System.Collections;
+using System.Collections.Generic;
+using UnityEngine;
+using UnityEngine.UI;
+
+public class DatePicker : MonoBehaviour
+{
+    public Date toSet;
+
+    public void ClosePanel()
+    {
+        // set nothing
+        this.gameObject.SetActive(false);
+    }
+
+    public void SetDate()
+    {
+        toSet.day = CalendarDayButton.day;
+        toSet.month = CalendarMonth.month;
+        toSet.year = CalendarYear.year;
+        this.gameObject.SetActive(false);
+    }
+}
diff --git a/Client/Client/Assets/Scripts/UI/DatePicker.cs.meta b/Client/Client/Assets/Scripts/UI/DatePicker.cs.meta
new file mode 100644
index 0000000..240cae4
--- /dev/null
+++ b/Client/Client/Assets/Scripts/UI/DatePicker.cs.meta
@@ -0,0 +1,11 @@
+fileFormatVersion: 2
+guid: 6cdb2579dcd9c184ea8611c77019710e
+MonoImporter:
+  externalObjects: {}
+  serializedVersion: 2
+  defaultReferences: []
+  executionOrder: 0
+  icon: {instanceID: 0}
+  userData: 
+  assetBundleName: 
+  assetBundleVariant: 
diff --git a/Client/Client/Assets/Scripts/UI/MapSwapper.cs b/Client/Client/Assets/Scripts/UI/MapSwapper.cs
new file mode 100644
index 0000000..b3bf6f7
--- /dev/null
+++ b/Client/Client/Assets/Scripts/UI/MapSwapper.cs
@@ -0,0 +1,63 @@
+﻿using System.Collections;
+using System.Collections.Generic;
+using UnityEngine;
+using UnityEngine.UI;
+
+public class MapSwapper : MonoBehaviour
+{
+    public WebGLMapController controller;
+    public MapRenderer map;
+    public CanvasGroup canvas;
+    public Text text;
+
+    public GameObject mapLegend;
+    public GameObject tableLegend;
+
+    public string toTable;
+    public string toMap;
+
+    private SpriteRenderer[] sprites;
+
+    private bool isMap = true;
+
+    public void Swap()
+    {
+        if (isMap)
+        {
+            isMap = false;
+            controller.blockExternal = true;
+
+            map.underlay.gameObject.SetActive(false);
+            sprites = map.GetComponentsInChildren<SpriteRenderer>(true);
+            foreach (var sprite in sprites)
+            {
+                sprite.color = new Color(sprite.color.r, sprite.color.g, sprite.color.b, 0f);
+            }
+
+            canvas.alpha = 1;
+            text.text = toMap;
+
+            mapLegend.SetActive(false);
+            tableLegend.SetActive(true);
+
+        }
+        else
+        {
+            isMap = true;
+            controller.blockExternal = false;
+
+            map.underlay.gameObject.SetActive(true);
+            sprites = map.GetComponentsInChildren<SpriteRenderer>(true);
+            foreach (var sprite in sprites)
+            {
+                sprite.color = new Color(sprite.color.r, sprite.color.g, sprite.color.b, 1f);
+            }
+
+            canvas.alpha = 0;
+            text.text = toTable;
+
+            mapLegend.SetActive(true);
+            tableLegend.SetActive(false);
+        }
+    }
+}
diff --git a/Client/Client/Assets/Scripts/UI/MapSwapper.cs.meta b/Client/Client/Assets/Scripts/UI/MapSwapper.cs.meta
new file mode 100644
index 0000000..5068eb1
--- /dev/null
+++ b/Client/Client/Assets/Scripts/UI/MapSwapper.cs.meta
@@ -0,0 +1,11 @@
+fileFormatVersion: 2
+guid: e5ba1461001096748aa5ea7d9c11b595
+MonoImporter:
+  externalObjects: {}
+  serializedVersion: 2
+  defaultReferences: []
+  executionOrder: 0
+  icon: {instanceID: 0}
+  userData: 
+  assetBundleName: 
+  assetBundleVariant: 
diff --git a/Client/Client/Assets/Scripts/UI/WeatherPanel.cs b/Client/Client/Assets/Scripts/UI/WeatherPanel.cs
index c5be4da..83607ed 100644
--- a/Client/Client/Assets/Scripts/UI/WeatherPanel.cs
+++ b/Client/Client/Assets/Scripts/UI/WeatherPanel.cs
@@ -1,4 +1,5 @@
 ﻿using ServerApp.Parser.OutputInfo;
+using System;
 using System.Collections;
 using System.Collections.Generic;
 using UnityEngine;
@@ -6,12 +7,14 @@ using UnityEngine.UI;
 
 public class WeatherPanel : PopUpPanel
 {
+    public RushManager rushManager;
     public WeatherManager weatherManager;
 
     public string[] weather = new string[] { "SUNNY", "CLOUDY", "OVERCAST", "DARK" };
     public int weatherIndex = 0;
 
     public Text weatherText;
+    public Text errorText;
 
     public Button weatherButton;
     public Button resetWeatherButton;
@@ -29,7 +32,7 @@ public class WeatherPanel : PopUpPanel
         weatherIndex -= 1;
         if (weatherIndex < 0)
             weatherIndex = weather.Length - 1;
-        weatherText.text = weather[weatherIndex];
+        SetWeatherText();
     }
 
     public void OnNextButtonPressed()
@@ -37,38 +40,111 @@ public class WeatherPanel : PopUpPanel
         weatherIndex += 1;
         if (weatherIndex > weather.Length - 1)
             weatherIndex = 0;
-        weatherText.text = weather[weatherIndex];
+        SetWeatherText();
+    }
+
+    private void SetWeatherText()
+    {
+        // the array literally doesn't work.
+        // the indexing was literally wrong.
+        // probably stuck somewhere in VS cause it was switched around when i first wrote it.
+        switch (weatherIndex)
+        {
+            case 0:
+                weatherText.text = "SUNNY";
+                break;
+            case 1:
+                weatherText.text = "CLOUDY";
+                break;
+            case 2:
+                weatherText.text = "OVERCAST";
+                break;
+            default:
+                weatherText.text = "DARK";
+                break;
+        }
     }
 
     public void OnSetWeatherButtonPressed()
     {
-        WeatherConditions weatherValue = (WeatherConditions)weatherIndex;
+        WeatherConditions weatherValue;
+
+        //Debug.Log($"The weather is {weatherIndex}");
 
-        if (temperature.text.Length == 0)
+        switch (weatherIndex)
         {
-            temperatureAnimator.SetTrigger("play");
-            return;
+            case 0:
+                weatherValue = WeatherConditions.Sunny;
+                break;
+            case 1:
+                weatherValue = WeatherConditions.Cloudy;
+                break;
+            case 2:
+                weatherValue = WeatherConditions.Overcast;
+                break;
+            default:
+                weatherValue = WeatherConditions.Dark;
+                break;
         }
 
-        if (rain.text.Length == 0)
+        //Debug.Log($"That means {weatherValue}");
+
+        double temperatureValue = Parse(temperature.text, temperatureAnimator);
+        double windValue = Parse(wind.text, windAnimator);
+        double rainValue = Parse(rain.text, rainAnimator);
+
+        if (double.IsNaN(temperatureValue) || double.IsNaN(windValue) || double.IsNaN(rainValue))
         {
-            rainAnimator.SetTrigger("play");
+            errorText.gameObject.SetActive(true);
+            errorText.text = "ALL VALUES MUST BE NUMBERS";
             return;
-        }
+        }    
 
-        if (wind.text.Length == 0)
+        if (rainValue < 0)
         {
-            windAnimator.SetTrigger("play");
+            errorText.gameObject.SetActive(true); 
+            errorText.text = "RAIN PROBABILITY MUST BE POSITIVE";
             return;
         }
 
-        double temperatureValue = double.Parse(temperature.text);
-        double windValue = double.Parse(wind.text);
-        double rainValue = double.Parse(rain.text);
+        if (windValue < 0)
+        {
+            errorText.gameObject.SetActive(true); 
+            errorText.text = "WIND SPEED MUST BE POSITIVE";
+            return;
+        }
 
+        errorText.gameObject.SetActive(false);
+        weatherManager.useOwnWeather = true;
         weatherManager.data.SetValues(temperatureValue, windValue, rainValue, weatherValue);
         weatherButton.gameObject.SetActive(false);
         resetWeatherButton.gameObject.SetActive(true);
+        rushManager.ResetRush();
         OnExitButtonClicked();
     }
+
+    public void OnResetWeatherButtonPressed()
+    {
+        weatherManager.useOwnWeather = false;
+        rushManager.ResetRush();
+    }
+
+    private double Parse(string text, Animator animator)
+    {
+        if (text.Length == 0)
+        {
+            animator.SetTrigger("play");
+            return double.NaN;
+        }
+
+        double value;
+        bool ok = double.TryParse(text, out value);
+        if (!ok)
+        {
+            animator.SetTrigger("play");
+            return double.NaN;
+        }
+        return value;
+    }
+
 }
diff --git a/Client/Client/Assets/Scripts/Weather/Parser/WeatherConditions.cs b/Client/Client/Assets/Scripts/Weather/Parser/WeatherConditions.cs
index 6c8b760..03a5bbc 100644
--- a/Client/Client/Assets/Scripts/Weather/Parser/WeatherConditions.cs
+++ b/Client/Client/Assets/Scripts/Weather/Parser/WeatherConditions.cs
@@ -10,6 +10,6 @@ namespace ServerApp.Parser.OutputInfo
     /// <author>A. Konig</author>
     public enum WeatherConditions
     {
-        Sunny, Cloudy, Overcast, Dark
+        Sunny = 0, Cloudy = 1, Overcast = 2, Dark = 3
     }
 }
\ No newline at end of file
diff --git a/Client/Client/Assets/Scripts/Weather/WeatherData.cs b/Client/Client/Assets/Scripts/Weather/WeatherData.cs
index 9eda53a..6590199 100644
--- a/Client/Client/Assets/Scripts/Weather/WeatherData.cs
+++ b/Client/Client/Assets/Scripts/Weather/WeatherData.cs
@@ -19,7 +19,7 @@ public class WeatherData
         Rain = rain;
         Weather = weather;
 
-        Debug.Log($"Setting: tmp={temperature}, wind={wind}, rain={rain}, weather={weather}");
+        //Debug.Log($"Setting: tmp={temperature}, wind={wind}, rain={rain}, weather={weather}");
 
         foreach (var observer in observers)
             observer.Notify(this);
diff --git a/Client/Client/Assets/Scripts/Weather/WeatherManager.cs b/Client/Client/Assets/Scripts/Weather/WeatherManager.cs
index 999988d..1715f3e 100644
--- a/Client/Client/Assets/Scripts/Weather/WeatherManager.cs
+++ b/Client/Client/Assets/Scripts/Weather/WeatherManager.cs
@@ -16,7 +16,7 @@ public class WeatherManager : MonoBehaviour, WeatherObserver
     public Text rainText;
     public Text windText;
 
-    public bool useOwnWeather = false;
+    public bool useOwnWeather;
 
     void Start()
     {
@@ -52,6 +52,12 @@ public class WeatherManager : MonoBehaviour, WeatherObserver
 
     public void SetWeather(Request request)
     {
+        SetWeather(request, useOwnWeather);
+    }
+
+    public void SetWeather(Request request, bool useOwnWeather)
+    {
+        this.useOwnWeather = useOwnWeather;
         request.useWeather = useOwnWeather;
         if (useOwnWeather)
         {
@@ -62,6 +68,14 @@ public class WeatherManager : MonoBehaviour, WeatherObserver
         }
     }
 
+    public void SetDateTime(Date dateTime)
+    {
+        if (!useOwnWeather)
+        {
+            provider.Load(dateTime);
+        }
+    }
+
     public void Clear()
     {
         provider = new WeatherProvider(data, networkingManager);
